
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   16:33:44 11/20/2008
-- Design Name:   fir
-- Module Name:   D:/XiLinx_Projekter/BASYS_PROJECTS/EXER/EXER6x/Exer6_7_FIR_filters/FIR_Filter4/My_own_Testbench_Filter_4.vhd
-- Project Name:  FIR_Filter4
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: fir
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
use IEEE.std_logic_arith.all;       -- <<<<< Note the use of std_logic_arith
use IEEE.MATH_REAL.ALL;             -- <<<<< Note the use of MATH_REAL

ENTITY My_own_Testbench_Filter_4_vhd IS
END My_own_Testbench_Filter_4_vhd;

ARCHITECTURE behavior OF My_own_Testbench_Filter_4_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT fir
	PORT(
		GLOBAL_CLK : IN std_logic;
		GLOBAL_RESET : IN std_logic;
		X_IN : IN std_logic_vector(15 downto 0);          
		NEW_SAMPLE : OUT std_logic;
		SATURATION_ERR : OUT std_logic;
		Y_OUT : OUT std_logic_vector(15 downto 0)
		);
	END COMPONENT;

	--Inputs
	SIGNAL GLOBAL_CLK :  std_logic := '0';
	SIGNAL GLOBAL_RESET :  std_logic := '0';
	SIGNAL X_IN :  std_logic_vector(15 downto 0) := (others=>'0');

	--Outputs
	SIGNAL NEW_SAMPLE :  std_logic;
	SIGNAL SATURATION_ERR :  std_logic;
	SIGNAL Y_OUT :  std_logic_vector(15 downto 0);

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: fir PORT MAP(
		GLOBAL_CLK => GLOBAL_CLK,
		GLOBAL_RESET => GLOBAL_RESET,
		X_IN => X_IN,
		NEW_SAMPLE => NEW_SAMPLE,
		SATURATION_ERR => SATURATION_ERR,
		Y_OUT => Y_OUT
	);

   Clock_generator: -- 52.5 MHz
	PROCESS
	BEGIN
	   GLOBAL_CLK   <= '0';
		GLOBAL_RESET <= '0';
	   wait for 10 ns;		
		GLOBAL_RESET <= '1';
	   wait for 10 ns;		
	   GLOBAL_CLK   <= '1';
	   wait for 10 ns;		
		GLOBAL_RESET <= '0';	
	   wait for 10 ns;		
	   GLOBAL_CLK   <= '0';		
	   wait for 50 ns;
		
		LOOP
	      GLOBAL_CLK <= NOT GLOBAL_CLK;
		   wait for 9538 ps;
		END LOOP;
	END PROCESS;

--   Square_Wave_generator: -- 1 MHz
--	PROCESS
--	   Variable Delay: integer := 1;
--	BEGIN
--	   X_IN <= "0000000100000000";
--	   for x in 0 to delay loop
--		   wait for 50 ns;
--		end loop; 
--	   X_IN <= "0000000000000001";
--	   for x in 0 to delay loop
--		   wait for 50 ns;
--		end loop;
--      Delay := Delay +1; 		
--	END PROCESS;
	
   Sinus_generator:
   PROCESS
	   constant Umax:      integer := 127;     -- Max amplitude
		constant f:         real    := 2.0E6;  -- Frequency [Hz] -???? Tjek
		constant Tper:      real    := 1.0/f;   -- Period of fr.
	-- If you can find a way to convert real to time please let me know
      constant Delta:     real    := 1000.0E-12; -- delta time - sec 
      constant DeltaWait: time    := 200000 ps;    -- delta time - ps		
	--------------------------------------------------------------------	
	   variable t:     Real := 0.0;  -- Actual time
		variable angle: real := 0.0;  -- Actual angle in radians
		variable Usin:  real := 0.0;  -- The sin value [real]
		variable Usin_int: integer;   -- The sin value as integer
	BEGIN
      while angle < MATH_2_PI*200.0 loop         -- go for to periodes
	      angle 	:= 2.0 * MATH_PI * t * f;    -- calculate angle
			t     	:= t + Delta;                -- next time 
			Usin  	:= real(Umax)*( SIN( angle)+1.0); -- Usin calculation
			Usin_int := integer(Usin);                 -- convert real to integer
			X_IN  <= conv_std_logic_vector( Usin_int, 16);  -- to vector
			wait for DeltaWait;                         -- Wait one delta time
	   end loop;
		wait;      -- forever / stop the process
	END PROCESS;

END;
